<?php

namespace Ilios\WebBundle\DependencyInjection;

use Symfony\Component\DependencyInjection\ContainerBuilder;
use Symfony\Component\Config\FileLocator;
use Symfony\Component\HttpKernel\DependencyInjection\Extension;
use Symfony\Component\DependencyInjection\Loader;

/**
 * This is the class that loads and manages your bundle configuration
 *
 * To learn more see {@link http://symfony.com/doc/current/cookbook/bundles/extension.html}
 */
class IliosWebExtension extends Extension
{
    /**
     * {@inheritdoc}
     */
    public function load(array $configs, ContainerBuilder $container)
    {
        $configuration = new Configuration();
        $config = $this->processConfiguration($configuration, $configs);

        //inject configuration data into the container
        $container->setParameter('ilios_web.environment', $config['environment']);
        $container->setParameter('ilios_web.version', $config['version']);

        if ($config['environment'] == 'production') {
            $container->setParameter('ilios_web.bucket_url', $config['production_bucket_path']);
        }
        if ($config['environment'] == 'staging') {
            $container->setParameter('ilios_web.bucket_url', $config['staging_bucket_path']);
        }
        $loader = new Loader\YamlFileLoader($container, new FileLocator(__DIR__.'/../Resources/config'));
        $loader->load('services.yml');


    }
}
